Subject: Re: netlink stats: Ability to get stats for a single device?

From: Ben Greear <[email-masked]>
Date: Tue, 26 Oct 2010 13:29:18 -0700

On 10/26/2010 12:56 PM, Eric Dumazet wrote:
> Le mardi 26 octobre 2010 à 12:38 -0700, David Miller a écrit :
>> From: Ben Greear<[email-masked]>
>> Date: Tue, 26 Oct 2010 12:31:12 -0700
>>
>>> Am I missing something, or do I just need to write up a patch
>>> to have netlink pay attention to the ifindex?
>>
>> Setting the ->ifi_index or IFLA_IFNAME attribute values appropriately
>> in the getlink request doesn't work?
>>
>> That should give you back, amonst other things, the rtnl_link_stats
>> for the device in the netlink response.
>> --
>
> Yep, it should be easy to change iproute2 to not ask a full dump
> in ip/ipaddress.c :
>
> if (rtnl_wilddump_request(&rth, preferred_family, RTM_GETLINK)<  0) ...
>
> and instead use rtnl_send() or something like that, if user provided one
> specific interface name   (or index)
>
> ip link show dev eth0

I'm trying to craft my own netlink message...basically:

    memset(&snl, 0, sizeof(snl));
    snl.nl_family = AF_NETLINK;
    snl.nl_pid    = 0;
    snl.nl_groups = 0;

    memset(&buffer, 0, sizeof(buffer));
    nlh->nlmsg_type = msg_type;
    nlh->nlmsg_flags = NLM_F_MATCH|NLM_F_REQUEST;
    static unsigned int nl_seqno = 1;
    nlh->nlmsg_seq = nl_seqno++;
    nlh->nlmsg_pid = nl_pid;

       nlh->nlmsg_len = NLMSG_LENGTH(sizeof(*ifinfomsg));
       ifinfomsg = (struct ifinfomsg*)(NLMSG_DATA(nlh));
       ifinfomsg->ifi_family = AF_UNSPEC;
       ifinfomsg->ifi_type = IFLA_UNSPEC;
       ifinfomsg->ifi_index = if_index;
       ifinfomsg->ifi_flags = 0;
       ifinfomsg->ifi_change = 0xffffffff;

It's possible that I'm somehow messing this up. But, looking at the
static int rtnl_dump_ifinfo(struct sk_buff *skb, struct netlink_callback *cb)
method, I cannot see how it would bail out properly after a single dev
has been processed, either.

Thanks,
Ben

-- 
Ben Greear <[email-masked]>
Candela Technologies Inc  http://www.candelatech.com